// FormDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "resource.h"
#include "uusbd.h"
#include "FormDlg.h"
#include "TestUSB.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormDlg _CAO


CFormDlg::CFormDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFormDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFormDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	husb=Uusbd_Open();
	Uusbd_ResetDevice(husb);

	h1=Uusbd_OpenPipe(husb,0,0);		//PԖڂEndpoint
	h2=Uusbd_OpenPipe(husb,0,1);		//QԖڂEndpoint
	h3=Uusbd_OpenPipe(husb,0,2);		//RԖڂEndpoint
}

CFormDlg::~CFormDlg()
{
	CloseHandle(h1);
	CloseHandle(h2);
	CloseHandle(h3);

	Uusbd_Close(husb);
}


void CFormDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormDlg)
                //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormDlg, CDialog)
	//{{AFX_MSG_MAP(CFormDlg)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormDlg bZ[W nh

void CFormDlg::OnSend() 
{


	for(int ii=0;ii<10;ii++) dummy[ii]=0;
	GetDlgItemText( IDC_WRITE, dummy,9 );

	buf[0]=aa[0];
	buf[1]=aa[1];
	buf[2]=0x03;
	buf[3]=0x00;
	strcpy(buf+4,dummy);

	WriteFile(h3,buf,64,&size,NULL);
	ReadFile(h2,buf,64,&size,NULL);


	SetDlgItemText( IDC_READ, buf+4);
}

void CFormDlg::OnOK() 
{
}

BOOL CFormDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	Uusbd_GetConfigurationDescriptor(husb,buf,9);

	//reset
	buf[0]=0x03;
	buf[1]=0x0C;
	buf[2]=0x00;

	BYTE a;

	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,3,buf);

	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);

//0e,04,01,03,0c,00
//AhXǂ
	buf[0]=0x09;
	buf[1]=0x10;
	buf[2]=0x00;
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,3,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);

//0e,0a,01,09,10,00,48,11,09,83,15,00
//Oݒ
	for(int i=0;i<256;i++) buf[i]=0;

	buf[0]=0x13;
	buf[1]=0x0c;
	buf[2]=0x04;
	buf[3]='y';
	buf[4]='t';
	buf[5]='s';
	buf[6]=0x00;

	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x07,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);

//0e,04,01,13,0c,00
//XLWrite Scan Enable Command
	buf[0]=0x1A;
	buf[1]=0x0C;
	buf[2]=0x01;
	buf[3]=0x03;

	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x04,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);
//0e,04,01,1a,0c,00

//Inquiry (T)
	buf[0]=0x01;
	buf[1]=0x04;
	buf[2]=0x05;
	buf[3]=0x33;//LAP 
	buf[4]=0x8b;
	buf[5]=0x9e;
	buf[6]=0x05;//wait (5 * 1.28 sec)
	buf[7]=0x01;

	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x08,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x02);

//02.0f,01,11,65,0f,dc,1b,00,01,00,00,00,00,00,c9,62,00

//Create Connectioniڑj
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x01);

	buf[0]=0x05;
	buf[1]=0x04;
	buf[2]=0x0D;
//	buf[3]=0x11;//address should be maintained
//	buf[4]=0x65;
//	buf[5]=0x0f;
//	buf[6]=0xdc;
//	buf[7]=0x1b;
//	buf[8]=0x00;
	buf[9]=0x01;
	buf[10]=0x00;
	buf[11]=0x00;
	buf[12]=0x00;
	buf[13]=buf[15];//copy clock offset
	buf[14]=buf[16];
	buf[15]=0x00;
// Connection Complete
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x10,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x03);
//03,0b,00,0c,00,11,65,0f,dc,1b,00,01,00

	if(buf[2]!=0) {
		MessageBox("Retry",NULL,MB_OK);
	}
	aa[0]=buf[3];aa[1]=buf[4]|0x20;
	
	return TRUE;  
}
