// bluehostDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "uusbd.h"
#include "bluehost.h"
#include "bluehostDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBluehostDlg _CAO

CBluehostDlg::CBluehostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBluehostDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBluehostDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBluehostDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBluehostDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBluehostDlg, CDialog)
	//{{AFX_MSG_MAP(CBluehostDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBluehostDlg bZ[W nh

BOOL CBluehostDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	husb=Uusbd_Open();
	if(husb==INVALID_HANDLE_VALUE) {
		MessageBox("USB cannot be opened !",NULL,MB_OK);
		CDialog::OnOK();
		return TRUE;
	}

	Uusbd_ResetDevice(husb);

	//see the endpoint order by using "USBVIEW.EXE"
	h1=Uusbd_OpenPipe(husb,0,0);//first  Endpoint 1(81) for HCI event
	//for PLANEX
	h2=Uusbd_OpenPipe(husb,0,1);//second Endpoint 2(02) for ACL data
	h3=Uusbd_OpenPipe(husb,0,2);//third  Endpoint 2(82) for ACL data
	//for non brand product
//	h3=Uusbd_OpenPipe(husb,0,1);//second Endpoint 2(82) for ACL data
//	h2=Uusbd_OpenPipe(husb,0,2);//third  Endpoint 2(02) for ACL data 


	BYTE a;int i;

	//a=Uusbd_GetConfigurationDescriptor(husb,buf,9);
	
	//Reset the PC dongle (use ClassRequest for HCI commands)
	buf[0]=0x03;
	buf[1]=0x0C;
	buf[2]=0x00;
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,3,buf);
	do{//responses for HCI commands are returned as HCI events to Endpoint 1(81)
		a=ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);
	//0e,04,01,03,0c,00

	//Read bd_address of the PC dongle
	buf[0]=0x09;
	buf[1]=0x10;
	buf[2]=0x00;
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,3,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);
//0e,0a,01,09,10,00,48,11,09,83,15,00

	//Set name for the PC dongle 
	for(i=0;i<256;i++) buf[i]=0;

	buf[0]=0x13;
	buf[1]=0x0c;
	buf[2]=0x04;
	buf[3]='Y';
	buf[4]='T';
	buf[5]='S';
	buf[6]=0x00;
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x07,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);
//0e,04,01,13,0c,00

	//Write Scan Enable Command (the PC dongle can be scanned by any other bluethooth devises)
	buf[0]=0x1A;
	buf[1]=0x0C;
	buf[2]=0x01;
	buf[3]=0x03;

	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x04,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x0e);
//0e,04,01,1a,0c,00


//Inquiry (search any other bluetooth dongles around you)
	buf[0]=0x01;
	buf[1]=0x04;
	buf[2]=0x05;
	buf[3]=0x33;
	buf[4]=0x8b;
	buf[5]=0x9e;
	buf[6]=0x05;//waiting time (5 * 1.28 sec)
	buf[7]=0x01;//if there are bluetooth devices around you, you should give a maximum number here. 
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x08,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x02);
//bd_address can be obtaind in buf[3-8]
//02.0f,01,   11,65,0f,dc,1b,00,             01,00,00,00,00,00,c9,62,00
//          / bd_address of the PIC dongle/

	//Create Connection (connection between the PC and PIC dongles)
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x01);

	buf[0]=0x05;
	buf[1]=0x04;
	buf[2]=0x0D;
	buf[3]=0x11;//******************************************
	buf[4]=0x65;//bd_address (6 octets) of the PIC bluetooth
	buf[5]=0x0f;//
	buf[6]=0xdc;//
	buf[7]=0x1b;//
	buf[8]=0x00;//******************************************
	buf[9]=0x10;//0x0010 DH1
	buf[10]=0x00;
	buf[11]=0x00;//00
	buf[12]=0x00;//00
	buf[13]=buf[15];//copy clock offset
	buf[14]=buf[16];//
	buf[15]=0x00;
	a=Uusbd_ClassRequest(husb,0,UU_RECIPIENT_INTERFACE,0,0,0,0x10,buf);
	do{
		ReadFile(h1,buf,64,&size,NULL);
	}while(buf[0]!=0x03);

// Connection Complete response begins with 0x03
//0f,04,  00,   01,05,04
//        00 must be zero (indicating no error)
//03,0b,  00,  0c,00,11,65,0f,dc,1b,00,01,00
//        00 must be zero

	if(buf[2]!=0) {// if no errors
		MessageBox("Connection Failed. Retry",NULL,MB_OK);CDialog::OnOK();return TRUE;
	}
	aa[0]=buf[3];aa[1]=buf[4]|0x20;//save connection handle and add (PB flag + BC flag)

	return TRUE;  
}

void CBluehostDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CBluehostDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBluehostDlg::OnOK() 
{
}

void CBluehostDlg::OnSend() 
{
	for(int ii=0;ii<10;ii++) dummy[ii]=0;
	GetDlgItemText( IDC_WRITE, dummy,0x20);//őf[^RQoCgƂĂB
	for(ii=0;ii<64;ii++) buf[ii]=0;

	//ACL header
	buf[0]=aa[0];// connection handle+ PB flag + BC flag
	buf[1]=aa[1];// 5.4.2 HCI ACL Data Packets of Core v2.0 + EDR.pdfB
	buf[2]=0x24; //f[^{S
	buf[3]=0x00; //0x0024̃gGfBA: 0x240x00
	buf[4]=0x20;//f[^igGfBAj
	buf[5]=0x00;
	buf[6]=0x40;//ɂ͖{`lhc^̂AHCI[ł
	buf[7]=0x00;//0x0040igGfBAjȏ̐^ĂΗǂA
		//f[^
	strcpy(buf+8,dummy);

	WriteFile(h2,buf,0x28,&size,NULL);//4+buf[2] (header length +data length)
	for(ii=0;ii<64;ii++) buf[ii]=0;
	ReadFile(h3,buf,64,&size,NULL);

	SetDlgItemText( IDC_READ, buf+8);

	//0x06,0x08,0x03,a[0],a[1],0x15 disconnect

}

void CBluehostDlg::OnClose() 
{
	CloseHandle(h1);
	CloseHandle(h2);
	CloseHandle(h3);

	Uusbd_Close(husb);	
	CDialog::OnClose();
}
